routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('contacts', 'ContactController');

app/Models/Contact/CastsAttributes/ChoiceType.php
<?php

declare(strict_types = 1);

namespace App\Models\Contact\CastsAttributes;

use Illuminate\Contracts\Database\Eloquent\CastsAttributes;
use App\Enum\ChoiceType as EnumChoiceType;

class ChoiceType implements CastsAttributes
{
    public function get($model, string $key, $value, array $attributes): EnumChoiceType
    {
        return new EnumChoiceType(EnumChoiceType::MAIN);
    }

    /** @param $value EnumChoiceType */
    public function set($model, string $key, $value, array $attributes): string
    {
        return $value->getValue();
    }
}

app/Models/Contact/Contact.php
<?php

namespace App\Models\Contact;

use App\Models\Contact\CastsAttributes\ChoiceType;
use Illuminate\Database\Eloquent\Model;

class Contact extends Model
{
    protected $fillable = [
        'first_name',
        'last_name',
        'email',
        'city',
        'country',
        'job_title',
        'type'
    ];

    protected $casts = [
        'type' => ChoiceType::class,
    ];
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/ContactController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ContactRequest;
use App\Http\ViewModels\ContactViewModel;
use App\Models\Contact\Contact;
use App\Services\ContactReportService;
use Symfony\Component\HttpFoundation\Response;

class ContactController extends Controller
{
    public function index(ContactReportService $contactReportService): Response
    {
        $reports = $contactReportService->getReport();

        return new Response(view('contacts.index', new ContactViewModel($reports)));
    }

    public function create(): Response
    {
        return new Response(view('contacts.create'));
    }

    public function store(ContactRequest $contactRequest, Contact $contact): Response
    {
        Contact::create($contactRequest->all());

        return redirect('/contacts')->with('success', 'Contact saved!');
    }

    public function edit(Contact $contact): Response
    {
        return new Response(view('contacts.edit', compact('contact')));
    }

    public function update(ContactRequest $contactRequest, Contact $contact): Response
    {
        $contact->update($contactRequest->all());

        return redirect('/contacts')->with('success', 'Contact updated!');
    }

    public function destroy(Contact $contact): Response
    {
        $contact->delete();

        return redirect('/contacts')->with('success', 'Contact deleted!');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/View/Components/Contact.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class Contact extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\View\View|string
     */
    public function render()
    {
        return view('components.contact');
    }
}

resources/views/base.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Laravel 7 & MySQL CRUD Tutorial</title>
    <link href="{{ asset('css/app.css') }}" rel="stylesheet" type="text/css"/>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
</head>
<body>
<div class="container">
    @yield('main')
</div>
<script src="{{ asset('js/app.js') }}" type="text/js"></script>
</body>
</html>

resources/views/contacts/create.blade.php
@extends('base')
@section('main')
    <div class="row">
        <div class="col-sm-8 offset-sm-2">
            <h1 class="display-3">Add a contact</h1>
            <div>
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div><br/>
                @endif
                <form method="post" action="{{ route('contacts.store') }}">
                    @csrf
                    <div class="form-group">
                        <label for="first_name">First Name:</label>
                        <input type="text" class="form-control" name="first_name"/>
                    </div>
                    <div class="form-group">
                        <label for="last_name">Last Name:</label>
                        <input type="text" class="form-control" name="last_name"/>
                    </div>
                    <div class="form-group">
                        <label for="email">Email:</label>
                        <input type="text" class="form-control" name="email"/>
                    </div>
                    <div class="form-group">
                        <label for="city">City:</label>
                        <input type="text" class="form-control" name="city"/>
                    </div>
                    <div class="form-group">
                        <label for="country">Country:</label>
                        <input type="text" class="form-control" name="country"/>
                    </div>
                    <div class="form-group">
                        <label for="job_title">Job Title:</label>
                        <input type="text" class="form-control" name="job_title"/>
                    </div>
                    <button type="submit" class="btn btn-primary-outline">Add contact</button>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/contacts/edit.blade.php
@extends('base')
@section('main')
    <div class="row">
        <div class="col-sm-8 offset-sm-2">
            <h1 class="display-3">Update a contact</h1>
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
                <br/>
            @endif
            <form method="post" action="{{ route('contacts.update', $contact->id) }}">
                @method('PATCH')
                @csrf
                <div class="form-group">
                    <label for="first_name">First Name:</label>
                    <input type="text" class="form-control" name="first_name" value={{ $contact->first_name }} />
                </div>
                <div class="form-group">
                    <label for="last_name">Last Name:</label>
                    <input type="text" class="form-control" name="last_name" value={{ $contact->last_name }} />
                </div>
                <div class="form-group">
                    <label for="email">Email:</label>
                    <input type="text" class="form-control" name="email" value={{ $contact->email }} />
                </div>
                <div class="form-group">
                    <label for="city">City:</label>
                    <input type="text" class="form-control" name="city" value={{ $contact->city }} />
                </div>
                <div class="form-group">
                    <label for="country">Country:</label>
                    <input type="text" class="form-control" name="country" value={{ $contact->country }} />
                </div>
                <div class="form-group">
                    <label for="job_title">Job Title:</label>
                    <input type="text" class="form-control" name="job_title" value={{ $contact->job_title }} />
                </div>
                <button type="submit" class="btn btn-primary">Update</button>
            </form>
        </div>
    </div>
@endsection

resources/views/contacts/index.blade.php
@extends('base')

@section('main')
    <div class="col-sm-12">
        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div>
        @endif
    </div>

    <div>
        <a style="margin: 19px;" href="{{ route('contacts.create')}}" class="btn btn-primary">New contact</a>
    </div>

    <div class="row">
        <div class="col-sm-12">
            <h1 class="display-3">Contacts</h1>
            <table class="table table-striped">
                <thead>
                <tr>
                    <td>Report ID</td>
                    <td>Report Name</td>
                    <td>Report Email</td>
                    <td>Report Job Title</td>
                    <td>Report City</td>
                    <td>Report Country</td>
                    <td colspan=2>Actions</td>
                </tr>
                </thead>
                <tbody>
                @foreach($reports as $report)
                    <tr>
                        <td>{{$report->getReportFirstName()}} {{$report->getReportLastName()}}</td>
                        <td>{{$report->getReportEmail()}}</td>
                        <td>{{$report->getReportJobTitle()}}</td>
                        <td>{{$report->getReportCity()}}</td>
                        <td>{{$report->getReportCountry()}}</td>
                        <td>{{$report->getReportType()->getValue()}}</td>
                        <td>
                            <a href="{{ route('contacts.edit',$report->getContactId())}}"
                               class="btn btn-primary">Edit</a>
                        </td>
                        <td>
                            <form action="{{ route('contacts.destroy', $report->getContactId())}}" method="post">
                                @csrf
                                @method('DELETE')
                                <button class="btn btn-danger" type="submit">Delete</button>
                            </form>
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>
        </div>
    </div>
@endsection